    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.awt.Container

    java.lang.Object
       |
       +----java.awt.Component
               |
               +----java.awt.Container

public abstract class Container
extends Component

A generic Abstract Window Toolkit(AWT) container object is a component that can contain other AWT components.

Components added to a container are tracked in a list. The order of the list will define the components' front-to-back stacking order within the container. If no index is specified when adding a component to a container, it will be added to the end of the list (and hence to the bottom of the stacking order).

See Also:
  add, getComponent, LayoutManager

##

Container()
  Constructs a new Container.

##

add(Component)
  Adds the specified component to the end of this container.
add(Component, int)
  Adds the specified component to this container at the given position.
add(Component, Object)
  Adds the specified component to the end of this container.
add(Component, Object, int)
  Adds the specified component to this container with the specified constraints at the specified index.
add(String, Component)
  Adds the specified component to this container.
addContainerListener(ContainerListener)
  Adds the specified container listener to receive container events from this container.
addImpl(Component, Object, int)
  Adds the specified component to this container at the specified index.
addNotify()
  Notifies the container to create a peer.
countComponents()
  Deprecated.
deliverEvent(Event)
  Deprecated.
doLayout()
  Causes this container to lay out its components.
getAlignmentX()
  Returns the alignment along the x axis.
getAlignmentY()
  Returns the alignment along the y axis.
getComponent(int)
  Gets the nth component in this container.
getComponentAt(int, int)
  Locates the component that contains the x,y position.
getComponentAt(Point)
  Gets the component that contains the specified point.
getComponentCount()
  Gets the number of components in this panel.
getComponents()
  Gets all the components in this container.
getInsets()
  Determines the insets of this container, which indicate the size of the container's border.
getLayout()
  Gets the layout manager for this container.
getMaximumSize()
  Returns the maximum size of this container.
getMinimumSize()
  Returns the minimum size of this container.
getPreferredSize()
  Returns the preferred size of this container.
insets()
  Deprecated.
invalidate()
  Invalidates the container.
isAncestorOf(Component)
  Checks if the component is contained in the component hierarchy of this container.
layout()
  Deprecated.
list(PrintStream, int)
  Prints a listing of this container to the specified output stream.
list(PrintWriter, int)
  Prints out a list, starting at the specified indention, to the specified print writer.
locate(int, int)
  Deprecated.
minimumSize()
  Deprecated.
paint(Graphics)
  Paints the container.
paintComponents(Graphics)
  Paints each of the components in this container.
paramString()
  Returns the parameter string representing the state of this container.
preferredSize()
  Deprecated.
print(Graphics)
  Prints the container.
printComponents(Graphics)
  Prints each of the components in this container.
processContainerEvent(ContainerEvent)
  Processes container events occurring on this container by dispatching them to any registered ContainerListener objects.
processEvent(AWTEvent)
  Processes events on this container.
remove(Component)
  Removes the specified component from this container.
remove(int)
  Removes the component, specified by `index`, from this container.
removeAll()
  Removes all the components from this container.
removeContainerListener(ContainerListener)
  Removes the specified container listener so it no longer receives container events from this container.
removeNotify()
  Notifies this container and all of its subcomponents to remove their peers.
setCursor(Cursor)
  Set the cursor image to a predefined cursor.
setLayout(LayoutManager)
  Sets the layout manager for this container.
update(Graphics)
  Updates the container.
validate()
  Validates this container and all of its subcomponents.
validateTree()
  Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid).

##

Container

     protected Container()

  Constructs a new Container. Containers can be extended directly, but are lightweight in this case and must be contained by a parent somewhere higher up in the component tree that is native. (such as Frame for example).

##

getComponentCount

     public int getComponentCount()

  Gets the number of components in this panel.

  Returns:
    the number of components in this panel.
  See Also:
    getComponent

countComponents

     public int countComponents()

  Note: countComponents() is deprecated. As of JDK version 1.1, replaced by getComponentCount().

getComponent

     public Component getComponent(int n)

  Gets the nth component in this container.

  Parameters:
    n - the index of the component to get.
  Returns:
    the nth component in this container.
  Throws: ArrayIndexOutOfBoundsException
    if the nth value does not exist.

getComponents

     public Component[] getComponents()

  Gets all the components in this container.

  Returns:
    an array of all the components in this container.

getInsets

     public Insets getInsets()

  Determines the insets of this container, which indicate the size of the container's border.

  A `Frame` object, for example, has a top inset that corresponds to the height of the frame's title bar.

  Returns:
    the insets of this container.
  See Also:
    Insets, LayoutManager

insets

     public Insets insets()

  Note: insets() is deprecated. As of JDK version 1.1, replaced by `getInsets()`.

add

     public Component add(Component comp)

  Adds the specified component to the end of this container.

  Parameters:
    comp - the component to be added.
  Returns:
    the component argument.

add

     public Component add(String name,
                          Component comp)

  Adds the specified component to this container. It is strongly advised to use the 1.1 method, add(Component, Object), in place of this method.

add

     public Component add(Component comp,
                          int index)

  Adds the specified component to this container at the given position.

  Parameters:
    comp - the component to be added.
    index - the position at which to insert the component, or `-1` to insert the component at the end.
  Returns:
    the component `comp`
  See Also:
    remove

add

     public void add(Component comp,
                     Object constraints)

  Adds the specified component to the end of this container. Also notifies the layout manager to add the component to this container's layout using the specified constraints object.

  Parameters:
    comp - the component to be added
    constraints - an object expressing layout contraints for this component
  See Also:
    LayoutManager

add

     public void add(Component comp,
                     Object constraints,
                     int index)

  Adds the specified component to this container with the specified constraints at the specified index. Also notifies the layout manager to add the component to the this container's layout using the specified constraints object.

  Parameters:
    comp - the component to be added
    constraints - an object expressing layout contraints for this
    index - the position in the container's list at which to insert the component. -1 means insert at the end. component
  See Also:
    remove, LayoutManager

addImpl

     protected void addImpl(Component comp,
                            Object constraints,
                            int index)

  Adds the specified component to this container at the specified index. This method also notifies the layout manager to add the component to this container's layout using the specified constraints object.

  This is the method to override if a program needs to track every add request to a container. An overriding method should usually include a call to the superclass's version of the method:

  > `super.addImpl(comp, constraints, index)`

  Parameters:
    comp - the component to be added.
    constraints - an object expressing layout contraints for this component.
    index - the position in the container's list at which to insert the component, where `-1` means insert at the end.
  See Also:
    add, add, add, LayoutManager

remove

     public void remove(int index)

  Removes the component, specified by `index`, from this container.

  Parameters:
    index - the index of the component to be removed.
  See Also:
    add

remove

     public void remove(Component comp)

  Removes the specified component from this container.

  Parameters:
    comp - the component to be removed
  See Also:
    add

removeAll

     public void removeAll()

  Removes all the components from this container.

  See Also:
    add, remove

getLayout

     public LayoutManager getLayout()

  Gets the layout manager for this container.

  See Also:
    doLayout, setLayout

setLayout

     public void setLayout(LayoutManager mgr)

  Sets the layout manager for this container.

  Parameters:
    mgr - the specified layout manager
  See Also:
    doLayout, getLayout

doLayout

     public void doLayout()

  Causes this container to lay out its components. Most programs should not call this method directly, but should invoke the `validate` method instead.

  Overrides:
    doLayout in class Component
  See Also:
    layoutContainer, setLayout, validate

layout

     public void layout()

  Note: layout() is deprecated. As of JDK version 1.1, replaced by `doLayout()`.

  Overrides:
    layout in class Component

invalidate

     public void invalidate()

  Invalidates the container. The container and all parents above it are marked as needing to be laid out. This method can be called often, so it needs to execute quickly.

  Overrides:
    invalidate in class Component
  See Also:
    validate, layout, LayoutManager

validate

     public void validate()

  Validates this container and all of its subcomponents.

  AWT uses `validate` to cause a container to lay out its subcomponents again after the components it contains have been added to or modified.

  Overrides:
    validate in class Component
  See Also:
    validate, invalidate

validateTree

     protected void validateTree()

  Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid). Synchronization should be provided by the method that calls this one: `validate`.

getPreferredSize

     public Dimension getPreferredSize()

  Returns the preferred size of this container.

  Returns:
    an instance of `Dimension` that represents the preferred size of this container.
  Overrides:
    getPreferredSize in class Component
  See Also:
    getMinimumSize, getLayout, preferredLayoutSize, getPreferredSize

preferredSize

     public Dimension preferredSize()

  Note: preferredSize() is deprecated. As of JDK version 1.1, replaced by `getPreferredSize()`.

  Overrides:
    preferredSize in class Component

getMinimumSize

     public Dimension getMinimumSize()

  Returns the minimum size of this container.

  Returns:
    an instance of `Dimension` that represents the minimum size of this container.
  Overrides:
    getMinimumSize in class Component
  See Also:
    getPreferredSize, getLayout, minimumLayoutSize, getMinimumSize

minimumSize

     public Dimension minimumSize()

  Note: minimumSize() is deprecated. As of JDK version 1.1, replaced by `getMinimumSize()`.

  Overrides:
    minimumSize in class Component

getMaximumSize

     public Dimension getMaximumSize()

  Returns the maximum size of this container.

  Overrides:
    getMaximumSize in class Component
  See Also:
    getPreferredSize

getAlignmentX

     public float getAlignmentX()

  Returns the alignment along the x axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.

  Overrides:
    getAlignmentX in class Component

getAlignmentY

     public float getAlignmentY()

  Returns the alignment along the y axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.

  Overrides:
    getAlignmentY in class Component

paint

     public void paint(Graphics g)

  Paints the container. This forwards the paint to any lightweight components that are children of this container. If this method is reimplemented, super.paint(g) should be called so that lightweight components are properly rendered. If a child component is entirely clipped by the current clipping setting in g, paint() will not be forwarded to that child.

  Parameters:
    g - the specified Graphics window
  Overrides:
    paint in class Component
  See Also:
    update

update

     public void update(Graphics g)

  Updates the container. This forwards the update to any lightweight components that are children of this container. If this method is reimplemented, super.update(g) should be called so that lightweight components are properly rendered. If a child component is entirely clipped by the current clipping setting in g, update() will not be forwarded to that child.

  Parameters:
    g - the specified Graphics window
  Overrides:
    update in class Component
  See Also:
    update

print

     public void print(Graphics g)

  Prints the container. This forwards the print to any lightweight components that are children of this container. If this method is reimplemented, super.print(g) should be called so that lightweight components are properly rendered. If a child component is entirely clipped by the current clipping setting in g, print() will not be forwarded to that child.

  Parameters:
    g - the specified Graphics window
  Overrides:
    print in class Component
  See Also:
    update

paintComponents

     public void paintComponents(Graphics g)

  Paints each of the components in this container.

  Parameters:
    g - the graphics context.
  See Also:
    paint, paintAll

printComponents

     public void printComponents(Graphics g)

  Prints each of the components in this container.

  Parameters:
    g - the graphics context.
  See Also:
    print, printAll

addContainerListener

     public synchronized void addContainerListener(ContainerListener l)

  Adds the specified container listener to receive container events from this container.

  Parameters:
    l - the container listener

removeContainerListener

     public synchronized void removeContainerListener(ContainerListener l)

  Removes the specified container listener so it no longer receives container events from this container.

  Parameters:
    l - the container listener

processEvent

     protected void processEvent(AWTEvent e)

  Processes events on this container. If the event is a ContainerEvent, it invokes the processContainerEvent method, else it invokes its superclass's processEvent.

  Parameters:
    e - the event
  Overrides:
    processEvent in class Component

processContainerEvent

     protected void processContainerEvent(ContainerEvent e)

  Processes container events occurring on this container by dispatching them to any registered ContainerListener objects. NOTE: This method will not be called unless container events are enabled for this component; this happens when one of the following occurs: a) A ContainerListener object is registered via addContainerListener() b) Container events are enabled via enableEvents()

  Parameters:
    e - the container event
  See Also:
    enableEvents

setCursor

     public synchronized void setCursor(Cursor cursor)

  Set the cursor image to a predefined cursor.

  Parameters:
    `cursor` - One of the constants defined by the `Cursor` class.
  Overrides:
    setCursor in class Component
  See Also:
    getCursor, Cursor

deliverEvent

     public void deliverEvent(Event e)

  Note: deliverEvent() is deprecated. As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`

  Overrides:
    deliverEvent in class Component

getComponentAt

     public Component getComponentAt(int x,
                                     int y)

  Locates the component that contains the x,y position. The top-most child component is returned in the case where there is overlap in the components. This is determined by finding the component closest to the index 0 that claims to contain the given point via Component.contains().

  Parameters:
    x - the x coordinate
    y - the y coordinate
  Returns:
    null if the component does not contain the position. If there is no child component at the requested point and the point is within the bounds of the container the container itself is returned; otherwise the top-most child is returned.
  Overrides:
    getComponentAt in class Component
  See Also:
    contains

locate

     public Component locate(int x,
                             int y)

  Note: locate() is deprecated. As of JDK version 1.1, replaced by `getComponentAt(int, int)`.

  Overrides:
    locate in class Component

getComponentAt

     public Component getComponentAt(Point p)

  Gets the component that contains the specified point.

  Parameters:
    p - the point.
  Returns:
    returns the component that contains the point, or `null` if the component does not contain the point.
  Overrides:
    getComponentAt in class Component
  See Also:
    contains

addNotify

     public void addNotify()

  Notifies the container to create a peer. It will also notify the components contained in this container. This method should be called by `Container.add`, and not by user code directly.

  Overrides:
    addNotify in class Component
  See Also:
    removeNotify

removeNotify

     public void removeNotify()

  Notifies this container and all of its subcomponents to remove their peers. This method should be invoked by the container's `remove` method, and not directly by user code.

  Overrides:
    removeNotify in class Component
  See Also:
    remove, remove

isAncestorOf

     public boolean isAncestorOf(Component c)

  Checks if the component is contained in the component hierarchy of this container.

  Parameters:
    c - the component
  Returns:
    `true` if it is an ancestor; `true` otherwise.

paramString

     protected String paramString()

  Returns the parameter string representing the state of this container. This string is useful for debugging.

  Returns:
    the parameter string of this container.
  Overrides:
    paramString in class Component

list

     public void list(PrintStream out,
                      int indent)

  Prints a listing of this container to the specified output stream. The listing starts at the specified indentation.

  Parameters:
    out - a print stream.
    indent - the number of spaces to indent.
  Overrides:
    list in class Component
  See Also:
    list

list

     public void list(PrintWriter out,
                      int indent)

  Prints out a list, starting at the specified indention, to the specified print writer.

  Overrides:
    list in class Component

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.